	
fFontSize = 0.013;
	
PreisAna = {};
PreisAna.moddir = g_currentModDirectory;
PreisAna.AnzeigeAktiv = true;
PreisAna.Produkte = {};
PreisAna.sortorder = {};
PreisAna.Breite_PR = 0;
PreisAna.Breite_VL = 0;
PreisAna.Breite_VK = 0;
PreisAna.xGr = 0;
PreisAna.yGr = 0;
PreisAna.xPos = 1;
PreisAna.yPos = 0.2;
PreisAna.ProdukteNeu = true;
PreisAna.MitBonus = true;
PreisAna.Toggle = false;
PreisAna.Modifier = false;
PreisAna.config = g_modsDirectory.."/Preisvergleich_cfg.xml";


PreisAna.timerPreis = { 
	id = nil,
	interval = 1000
	};

	
PreisAna.Produkt = {}
function PreisAna.Produkt.new()
	local self = {};	
	self.Preis = 0;
	self.Verkaufsstelle = "";
	self.indexDesc = nil;
	self.sPPL = 0;
	self.Value = 0;
	self.Vorrat = 0;
	self.Name = "";
	return self;
end;

PreisAna.colors = {
		white = 	{1.0,1.0,1.0,1.0};
		red = 		{1.0,0.3,0.3,1.0};
		yellow = 	{1.0,1.0,0.3,1.0};
		green = 	{0.3,1.0,0.3,1.0};
		verygreen = {0.1,1.0,0.1,1.0};
	};
	
-------------------------------------------------------------
--	PreisAna:loadMap(name)
-------------------------------------------------------------	
function PreisAna:loadMap(name)
	PreisAna.AnzeigeAktiv = true;
	PreisAna.Produkte = {};
	PreisAna.sortorder = {};
	PreisAna.Breite_PR = 0;
	PreisAna.Breite_VL = 0;
	PreisAna.Breite_VK = 0;
	PreisAna.xGr = 0;
	PreisAna.yGr = 0;
	PreisAna.xPos = 1;
	PreisAna.yPos = 0.2;
	PreisAna.ProdukteNeu = true;
	PreisAna.MitBonus = true;
	PreisAna.Toggle = false;
	PreisAna.Modifier = false;
	PreisAna.config = g_modsDirectory.."/Preisvergleich_cfg.xml";
	PreisAna:loadConfig();
	PreisAna.timerPreis.id = addTimer(1, "ZZZ_Preisvergleich.timerPreis");
	PreisAna.FaktorDif = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1);
	PreisAna.ovid = createImageOverlay(Utils.getFilename("Overlay.png", PreisAna.moddir));
end;

-------------------------------------------------------------
--	PreisAna:deleteMap()
-------------------------------------------------------------
function PreisAna:deleteMap()
	PreisAna:saveConfig();
	removeTimer(PreisAna.timerPreis.id)
	PreisAna.Produkte = {};
end;

-------------------------------------------------------------
--	PreisAna:mouseEvent(posX, posY, isDown, isUp, button)
-------------------------------------------------------------
function PreisAna:mouseEvent(posX, posY, isDown, isUp, button)
end;


-------------------------------------------------------------
--	PreisAna:keyEvent(unicode, sym, modifier, isDown)
-------------------------------------------------------------
function PreisAna:keyEvent(unicode, sym, modifier, isDown)
end;

-------------------------------------------------------------
--	PreisAna:update(dt)
-------------------------------------------------------------
function PreisAna:update(dt)
	if InputBinding.isPressed(InputBinding.PreisAna_TOGGLE) then -- TOGGLE gehalten
		PreisAna.Toggle = true;

		if PreisAna.AnzeigeAktiv then
			if Input.keyPressedThisFrame[Input.KEY_lctrl] then -- lSTRG => Bonusberechnung ändern
				PreisAna.MitBonus = not PreisAna.MitBonus;
				PreisAna.ProdukteNeu = true;
				PreisAna.Modifier = true;
				timerPreis();
			elseif Input.keyPressedState[Input.KEY_left] then
				PreisAna.xPos = math.max(0,PreisAna.xPos - 0.0025);
				--if PreisAna.yPos < 0.5 then PreisAna.yPos=0 else PreisAna.yPos=1 end;
				PreisAna.Modifier = true;
			elseif Input.keyPressedState[Input.KEY_right] then
				PreisAna.xPos = math.min(1,PreisAna.xPos + 0.0025);
				--if PreisAna.yPos < 0.5 then PreisAna.yPos=0 else PreisAna.yPos=1 end;
				PreisAna.Modifier = true;
			elseif Input.keyPressedState[Input.KEY_down] then
				PreisAna.yPos = math.max(0,PreisAna.yPos - 0.0025);
				--if PreisAna.xPos < 0.5 then PreisAna.xPos=0 else PreisAna.xPos=1 end;
				PreisAna.Modifier = true;
			elseif Input.keyPressedState[Input.KEY_up] then	
				PreisAna.yPos = math.min(1,PreisAna.yPos + 0.0025);
				--if PreisAna.xPos < 0.5 then PreisAna.xPos=0 else PreisAna.xPos=1 end;
				PreisAna.Modifier = true;
			end;
		end;
		
	elseif PreisAna.Toggle and not PreisAna.Modifier then
		PreisAna.AnzeigeAktiv = not PreisAna.AnzeigeAktiv;
		PreisAna.Toggle = false;
		PreisAna.Modifier = false;
	end;
	
end;

-------------------------------------------------------------
--	PreisAna:draw()
-------------------------------------------------------------
function PreisAna:draw()
	if (PreisAna.AnzeigeAktiv) and not PreisAna.ProdukteNeu and (not g_currentMission.ingameMap.isFullSize or PreisAna.xPos > 0.66) then 
			
		setTextBold(false);
				
		local y = PreisAna.yPos * (1 - PreisAna.yGr);
		local x = PreisAna.xPos * (1 - PreisAna.xGr);
				
		renderOverlay( PreisAna.ovid, x, y , PreisAna.xGr , PreisAna.yGr )
		
		y = y + PreisAna.yGr - 1.35 * fFontSize;
		for i, index in pairs(PreisAna.sortorder) do
			local ActProdukt = PreisAna.Produkte[index];
			if (ActProdukt.Value <= 95) then
				setTextColor(unpack(self.colors['red']));
			elseif (ActProdukt.Value < 105) then
				setTextColor(unpack(self.colors['yellow']));
			elseif (ActProdukt.Value < 130) then
				setTextColor(unpack(self.colors['green']));
			else
				setTextColor(unpack(self.colors['verygreen']));
			end;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText( x, y, fFontSize, "  "..ActProdukt.Name );
			setTextAlignment(RenderText.ALIGN_RIGHT);			
			renderText( x + PreisAna.Breite_PR + PreisAna.Breite_VL, y, fFontSize, string.format("%s", ActProdukt.Value) .. "% ")
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText( x + PreisAna.Breite_PR + PreisAna.Breite_VL, y, fFontSize,  "  "..ActProdukt.Verkaufsstelle );
			y = y - fFontSize
		end;
	end;	
end;

-------------------------------------------------------------
--	timerPreis()
-------------------------------------------------------------
function timerPreis()
	Preis();
	setTimerTime(PreisAna.timerPreis.id, PreisAna.timerPreis.interval);
	return true;
end;

-------------------------------------------------------------
--	Preis()
-------------------------------------------------------------
function Preis()

	local ActProdukt = {};
	if (PreisAna.AnzeigeAktiv) then -- Wenn active
		if (PreisAna.ProdukteNeu) then -- Wenn Produkttable neu gemacht werden muss
		
			PreisAna.ProdukteNeu = false;
			PreisAna.Produkte = {};
			PreisAna.Breite_VK = 0;
			PreisAna.Breite_PR = 0;
			PreisAna.Breite_VL = getTextWidth(fFontSize," 999% ");
			PreisAna.yGr = fFontSize;
			
			--print("Preis: Produkttabelle erstellen!");tipTriggers
			for k,tipTrigger in pairs(g_currentMission.tipTriggers) do -- In TipTriggern vorhandene Produkte in Produkte[] eintragen
				if getUserAttribute(tipTrigger.triggerId, "appearsOnPDA") then 
					
					local fillTypes = getUserAttribute(tipTrigger.triggerId, "fillTypes");
					if fillTypes == nil then
						fillTypes = getUserAttribute(tipTrigger.triggerId, "fruitTypes");
					end
					
					local types = Utils.splitString(" ", fillTypes);
					for i, name in pairs(types) do
						local desc = Fillable.fillTypeNameToDesc[name];						
						if (desc ~=nil) then
							if (tipTrigger.priceMultipliers[desc.index] ~= nil) then
							
								if (PreisAna.Produkte[name] == nil) then -- Produkt ist neu
									ActProdukt = PreisAna.Produkt.new();
									ActProdukt.indexDesc = desc.index;
									ActProdukt.Name = desc.nameI18N;
									ActProdukt.sPPL = 0;
									
									--print("Produkt: " .. ActProdukt.Name .. " hinzugefügt!");
									PreisAna.Produkte[name] = ActProdukt;
									PreisAna.Breite_PR = math.max(PreisAna.Breite_PR,getTextWidth(fFontSize, "  "..ActProdukt.Name.."  "));
								
									PreisAna.yGr = PreisAna.yGr + fFontSize;
								else 
									ActProdukt = PreisAna.Produkte[name];
								end;
															
								--print(ActProdukt.Name);
								--print(tipTrigger.stationName);
								--print("Multiplier: "..tipTrigger.priceMultipliers[ActProdukt.indexDesc]);
								--print("sPPL: "..desc.startPricePerLiter);
								
								local sPPL = PreisAna.FaktorDif * tipTrigger.priceMultipliers[ActProdukt.indexDesc] * desc.startPricePerLiter;
								if PreisAna.MitBonus and ((tipTrigger.stationName == "StationFreightYard") or (tipTrigger.stationName == "Bahnhof")) then
									if g_currentMission.missionStats.difficulty < 3 then
										sPPL = sPPL * 2.33;
									else
										sPPL = sPPL * 2.33;
									end;
								end;						
								if (sPPL > ActProdukt.sPPL) then 
									ActProdukt.sPPL = sPPL;
								end;
								
							end;
						end;
					end;

					local Triggername = g_i18n:getText(tipTrigger.stationName)
					if ( string.sub( Triggername, 1, 7) ==  "Missing" and string.sub( Triggername, string.len( Triggername) - 3, string.len( Triggername)) == ".xml") then
						Triggername = tipTrigger.stationName
					end;					
					PreisAna.Breite_VK = math.max(PreisAna.Breite_VK,getTextWidth(fFontSize, "  "..Triggername.."  "));
					
				end;
			end;
			
			PreisAna.xGr = PreisAna.Breite_PR + PreisAna.Breite_VL + PreisAna.Breite_VK;
		end;
			
		for i, ActProdukt in pairs(PreisAna.Produkte) do
			ActProdukt.Preis = 0;
		end;
		
		for k,tipTrigger in pairs(g_currentMission.tipTriggers) do
			if getUserAttribute(tipTrigger.triggerId, "appearsOnPDA") then 
				local Triggername = g_i18n:getText(tipTrigger.stationName)
				if ( string.sub( Triggername, 1, 7) ==  "Missing" and string.sub( Triggername, string.len( Triggername) - 3, string.len( Triggername)) == ".xml") then
					Triggername = tipTrigger.stationName
				end;
				
				for i, ActProdukt in pairs(PreisAna.Produkte) do					
					if ( tipTrigger.priceMultipliers[ActProdukt.indexDesc] ~= nil) then
					
						local Preis = PreisAna.FaktorDif * tipTrigger.priceMultipliers[ActProdukt.indexDesc] * Fillable.fillTypeIndexToDesc[ActProdukt.indexDesc].pricePerLiter;
						local Nachfrage = g_currentMission.economyManager:getCurrentGreatDemand(tipTrigger.stationName, ActProdukt.indexDesc);
						if Nachfrage ~= nil then
							Preis = Preis * Nachfrage.demandMultiplier;
						end;						
						if PreisAna.MitBonus and ((tipTrigger.stationName == "StationFreightYard") or (tipTrigger.stationName == "Bahnhof")) then
							if g_currentMission.missionStats.difficulty < 3 then
								Preis = Preis * 2.33;
							else
								Preis = Preis * 2.33;
							end;
						end;

						if ( Preis > ActProdukt.Preis ) then
							ActProdukt.Preis = Preis;
							PreisAna.Produkte[i].Verkaufsstelle = Triggername;
						end
					end;
				end;					
			end;
		end;
	
		for k, ActProdukt in pairs(PreisAna.Produkte) do
			ActProdukt.Value = math.ceil(ActProdukt.Preis / ActProdukt.sPPL * 100);
		end;
		
		PreisAna.sortorder = {};
		for k, ActProdukt in pairs(PreisAna.Produkte) do
			local placed = false;
			for i, index in pairs(PreisAna.sortorder) do
				if not placed and PreisAna.Produkte[index].Value < ActProdukt.Value then
					table.insert(PreisAna.sortorder,i,k);
					placed = true;
				end;
			end;
			if not placed then
				table.insert(PreisAna.sortorder,k);
			end;
		end;
		
	end;
end;	

function PreisAna:loadConfig()
	local XMLfile;
	if fileExists(self.config) then -- load config
		XMLfile = loadXMLFile("Preisvergleich_XML", self.config, "options");
	else -- create config file
		XMLfile = createXMLFile("Preisvergleich_XML", self.config, "options");
		setXMLFloat(XMLfile, "options.xPos", self.xPos);
		setXMLFloat(XMLfile, "options.yPos", self.yPos);
		setXMLBool(XMLfile, "options.MitBonus", self.MitBonus);
		saveXMLFile(XMLfile);
	end;
	if XMLfile ~= nil then
		self.xPos = getXMLFloat(XMLfile, "options.xPos");
		self.yPos = getXMLFloat(XMLfile, "options.yPos");
		self.MitBonus = getXMLBool(XMLfile, "options.MitBonus");
	end;
end;

function PreisAna:saveConfig()
	local XMLfile;
	if not fileExists(self.config) then
		XMLfile = createXMLFile("Preisvergleich_XML", self.config, "options");
	else
		XMLfile = loadXMLFile("Preisvergleich_XML", self.config, "options");
	end;
	if XMLfile ~= nil then
		setXMLFloat(XMLfile, "options.xPos", self.xPos);
		setXMLFloat(XMLfile, "options.yPos", self.yPos);
		setXMLBool(XMLfile, "options.MitBonus", self.MitBonus);
		saveXMLFile(XMLfile);
	end;
end;

addModEventListener(PreisAna);

local modItem = ModsUtil.findModItemByModName(g_currentModName);
print(string.format("--- loading %s mod V%.2f (by %s) ---", modItem.title, modItem.version, modItem.author));



